<template>
  <div>
    <q-toolbar class="text-primary text-center q-my-xs">
      <q-toolbar-title class="text-h4"> Issues </q-toolbar-title>
    </q-toolbar>

    <q-card class="bg-grey-3 q-pa-md">
      <q-card-section class="bg-white" style="border-radius: 15px">
        <q-select
          dense
          outlined
          v-model="parameter"
          :options="parameterOptions"
          label="Parameter"
        >
          <template v-slot:append>
            <q-icon name="cancel" color="grey" />
          </template>
        </q-select>

        <div class="q-mt-md row">
          <q-input class="col-8" dense outlined v-model="date">
            <template v-slot:append>
              <q-icon name="eva-calendar-outline" />
            </template>
          </q-input>         

          <div class="col-4 text-caption">
            <span class="justify-center row text-grey">50/80 Issues</span>
            <span class="justify-center row text-grey">Page 1/2</span>
          </div>
        </div>

        <q-separator class="q-mt-sm" />
        <q-tabs
          v-model="tab"
          narrow-indicator
          active-color="primary"
          align="justify"
        >
          <q-tab name="raised" label="raised" />
          <q-tab name="resolved" label="resolved" />
        </q-tabs>
        <q-separator class="q-mb-md" />

        <q-pagination
          v-model="currentPage"
          :max="2"
          direction-links
          class="justify-center q-my-sm"
        />
        <div class="text-right q-ma-xs">
            <q-btn fab icon="add" color="blue-6" @click="showForm" />
        </div>

        <q-tab-panels
          v-model="tab"
          animated
          swipeable
          transition-prev="jump-up"
          transition-next="jump-up"
        >
          <q-tab-panel name="raised">
              <q-list bordered separator>
                <q-card
                  v-for="issue in issueList"
                  :key="issue._id"
                >
                <div class="q-my-md" style="border-radius: 10px; border-left: 10px solid red">
                <q-item>
                  <q-item-section avatar>
                    <q-icon name="shower" />
                  </q-item-section>
                  <q-item-section class="text-bold q-pt-xs"
                    >{{ issue.issueName }}
                    </q-item-section
                  >
                  <q-item-section side>
                    <q-icon name="signal_cellular_alt" color="yellow" />
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section>
                    <q-item-label caption>Description</q-item-label>
                    <q-item-label class="text-bold text-uppercase"
                      >{{ issue.description }}</q-item-label
                    >
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section>
                    <q-item-label caption>Facility</q-item-label>
                    <q-item-label class="text-bold">{{ issue.facility }}</q-item-label>
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section class="text-grey"
                    >Last Friday at 5:11 PM</q-item-section
                  >
                  <q-item-section side>
                    <q-icon name="eva-info-outline" />
                  </q-item-section>
                  <q-item-section side>
                    <q-icon name="update" @click="updateForm(issue._id, issue.issueName, issue.description, issue.facility)"/>
                  </q-item-section>
                  <q-item-section side>
                    <q-icon name="delete_forever" @click="deleteIssue(issue._id)" />
                  </q-item-section>
                </q-item>
            </div>
                </q-card>
              </q-list>

            </q-tab-panel>

          <q-tab-panel name="resolved">
            <div
              class="q-mt-md"
              style="border-radius: 10px; border-left: 10px solid red"
            >
              <q-list bordered separator>
                <q-item>
                  <q-item-section avatar>
                    <q-icon name="shower" />
                  </q-item-section>
                  <q-item-section>Faucet</q-item-section>
                  <q-item-section side>
                    <q-icon name="signal_cellular_alt" color="green" />
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section>
                    <q-item-label caption>Description</q-item-label>
                    <q-item-label class="text-bold">Broken</q-item-label>
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section>
                    <q-item-label caption>Facility</q-item-label>
                    <q-item-label class="text-bold">Facility 1</q-item-label>
                  </q-item-section>
                </q-item>

                <q-item>
                  <q-item-section class="text-grey"
                    >Last Thursday at 11:32 AM</q-item-section
                  >
                  <q-item-section side>
                    <q-icon name="eva-info-outline" />
                  </q-item-section>
                  <q-item-section side>
                    <q-icon name="done" />
                  </q-item-section>
                  <q-item-section side>
                    <q-icon name="eva-calendar-outline" />
                  </q-item-section>
                </q-item>
              </q-list>
            </div>
          </q-tab-panel>
        </q-tab-panels>
      </q-card-section>
    </q-card>

    <!-- Add new Issues dialog -->
    <q-dialog v-model="issueDialog" persistent>
     <q-card style="width: 1000px; max-width: 1200px">
        <q-toolbar class="q-pa-md">
          <q-icon name="note_add" size="md" class="text-primary" />
          <q-toolbar-title
            >Add New Issue
          </q-toolbar-title>
          
        </q-toolbar>
        <q-separator />
        <q-form method="post" @submit="onSubmit" @reset="onReset">
          <q-card-section>
            <q-input
              label="Issue Name *"
              v-model="formData.issueName"
              lazy-rules
              :rules="[val => val !== null || 'Issue Name cannot be empty']"
            />
            <q-input
              label="Description *"
              v-model="formData.description"
              lazy-rules
              :rules="[(val) => (val && val.length > 0) || 'Description cannot be empty']"
            />
            <q-input
              label="Facility *"
              v-model="formData.facility"
              lazy-rules
              :rules="[(val) => (val && val.length > 0) || 'Facility cannot be empty']"
            />
          </q-card-section>
          <q-toolbar class="q-pa-md flex justify-end">
            <q-btn
              label="Submit"
              type="submit"
              align="between"
              color="positive"
              icon="check"
              class="q-ma-sm"
              dense
            />
            <q-btn
              label="Reset"
              type="reset"
              color="primary"
              flat
              class="q-ma-sm"
              dense
            />
            <q-btn
              label="Cancel"
              outline
              align="between"
              color="red-12"
              icon="clear"
              type="reset"
              v-close-popup
              class="q-ma-sm"
              dense
            />
          </q-toolbar>
        </q-form>
      </q-card>
    </q-dialog>

    <!-- Update issue dialog -->
    <q-dialog v-model="updateDialog" persistent>
     <q-card style="width: 1000px; max-width: 1200px">
        <q-toolbar class="q-pa-md">
          <q-icon name="note_add" size="md" class="text-primary" />
          <q-toolbar-title
            >Update Issue
          </q-toolbar-title>
          
        </q-toolbar>
        <q-separator />
        <q-form method="post" @submit="updateIssue">
          <q-card-section>
            <q-input
              label="Issue Name *"
              v-model="updateData.issueName"
              lazy-rules
              :rules="[val => val !== null || 'Issue Name cannot be empty']"
            />
            <q-input
              label="Description *"
              v-model="updateData.description"
              lazy-rules
              :rules="[(val) => (val && val.length > 0) || 'Description cannot be empty']"
            />
            <q-input
              label="Facility *"
              v-model="updateData.facility"
              lazy-rules
              :rules="[(val) => (val && val.length > 0) || 'Facility cannot be empty']"
            />
          </q-card-section>
          <q-toolbar class="q-pa-md flex justify-end">
            <q-btn
              label="Submit"
              type="submit"
              align="between"
              color="positive"
              icon="check"
              class="q-ma-sm"
              dense
            />
            <q-btn
              label="Cancel"
              outline
              align="between"
              color="red-12"
              icon="clear"
              type="reset"
              v-close-popup
              class="q-ma-sm"
              dense
            />
          </q-toolbar>
        </q-form>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { ref } from "vue";
import { useQuasar } from 'quasar';
import { api } from "boot/axios";

export default {
  setup() {
    return {
      parameter: ref("All Parameters"),
      date: "2022/03/01 - 2022/02/29",
      currentPage: 1,
      tab: "raised",

      parameterOptions: [
        "All Parameters",
        "Google",
        "Facebook",
        "Twitter",
        "Apple",
        "Oracle",
      ],
    };
  },

  data() {
    return {
      issueDialog: false,
      $q: useQuasar(),
      issueList: null,
      updateDialog: false,
      

      formData: {
        issueName:null,
        description: null,
        facility: null
      },

      updateData: {
        id:null,
        issueName:null,
        description: null,
        facility: null
      },
    }
  },

  created() {
    let url = '/issuesList'
    api.get(url)
    .then((response) => {
        if (response.status != 401) {
          this.issueList = response.data
        } else {
          // this.$router.push('/login') 
          this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : " + response.error
          });
        }
      });
  },

  methods: {
    showForm: function () {
      this.issueDialog = true;
    },

    updateForm: function (id, issueName, description, facility) {
      this.updateDialog = true;
      this.updateData.id = id,
      this.updateData.issueName = issueName,
      this.updateData.description = description,
      this.updateData.facility = facility
    },

    deleteOk: function (id) {
      api.delete("/issuesList/" + id, {  
      })
      .then((response) => {
        if (response.data.ok == true) {
          this.$q.notify({
            title: "Success",
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: "Issue deleted successfully."
          })
        } else {
          this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : " + response.data.error
          });
        }
      });

    },

    deleteIssue: function (id) {
      this.$q.dialog({
        title: 'Alert',
        message: 'Are you confirm to delete !!!',
        cancel: true,
        persistent: true
      }).onOk(() => {
        this.deleteOk(id)
      })
      
    },

    onReset : function () {
        this.formData.issueName = null,
        this.formData.description = null,
        this.formData.facility = null
    },

    onSubmit: function () {
      this.newIssue = {
        issueName: this.formData.issueName,
        description: this.formData.description,
        facility: this.formData.facility
      };
      api.post("/issuesList", {
        data: this.newIssue,
      })
      .then((response) => {
        if (response.data.ok === true) {
          this.$q.notify({
            title: "Success",
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: "New Issue added successfully."
          }),
          this.formDialog = false
          this.$router.go()
        } else {
          this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : " + response.data.error
          });
        }
      });
    },
    
    updateIssue: function () {
      this.newIssue = {
        issueName: this.updateData.issueName,
        description: this.updateData.description,
        facility: this.updateData.facility
      };
      api.put("/issuesList/" + this.updateData.id, {
        data: this.newIssue,
      })
      .then((response) => {
        if (response.data.ok === true) {
          this.$q.notify({
            title: "Success",
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: "Issue updated successfully."
          }),
          this.formDialog = false
          this.$router.go()
        } else {
          this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : " + response.data.error
          });
        }
      });
    },

    
  }
};
</script>
